//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * アンズ死亡状態実装
 * @author Junpee
 */

#include "Core/Utility/stdafx.h"
#include "Player/Anzu/AnzuDeathState.h"
#include "Game/Sound/SoundSystem.h"
#include "Player/System/Player.h"

#include "Player/Anzu/AnzuGetUpState.h"

//------------------------------------------------------------------------------
// 生成、破棄
//------------------------------------------------------------------------------
// コンストラクタ
AnzuDeathState::AnzuDeathState(Anzu* anzu) : AnzuState(anzu){
}
//------------------------------------------------------------------------------
// デストラクタ
AnzuDeathState::~AnzuDeathState(){
}
//------------------------------------------------------------------------------
// 実行
//------------------------------------------------------------------------------
// 初期化
void AnzuDeathState::initialize(){
	// 実行カウンタクリア
	runCounter_ = 0;
	// 音を鳴らす
	getSoundSystem()->play("AnzuDeath");
}
//------------------------------------------------------------------------------
// 後始末
void AnzuDeathState::finalize(){
}
//------------------------------------------------------------------------------
// 実行
void AnzuDeathState::run(){
	// 定数
	float animationScale = 1.f;

	// ステート変更
	if(runCounter_ == 90){
		if(!isAnnihilated()){
			// 全滅でなければ復活する
			setLife(getLife() - 1);
			setHealth(500);
			getPlayer()->setState(
				new AnzuGetUpState(getAnzu()));
		}else{
			// 全滅
		}
	}

	// 位置と速度の計算
	calcVelocityAndPosition(Vector3::zero);
	// 向きの設定
//	setDirection(-damageDirection_);

	// 地形コリジョン
	landCollide();

	// 描画セットアップ
	drawSetup(animationScale);

	// 実行カウンタインクリメント
	runCounter_++;
}
//------------------------------------------------------------------------------
